﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Xml.Linq;
using ASPItalia.App4Windows8.Xaml.Model;

namespace ASPItalia.App4Windows8.Xaml.Common
{
    public class SectionHttpClient
    {
        public async Task<Section> LoadSectionAsync(Uri url, string title)
        {
            // TODO
            var doc = XDocument.Load(url.ToString());

            var section = new Section();
            section.Title = title;

            var items = doc.Descendants("item").Select(x =>
                new SectionItem
                {
                    Title = x.Element("title").Value,
                    Uri = TryParseUri(x.Element("link")),
                    PubDate = TryParseDateTime(x.Element("pubDate")),
                    Content = x.Element("description").Value,
                    // TODO: altre proprietà

                    Section = section,
                });

            foreach (var item in items)
            {
                section.Items.Add(item);
            }

            return section;
        }

        private DateTime TryParseDateTime(XElement xElement)
        {
            // TODO
            return DateTime.Now;
        }

        private Uri TryParseUri(XElement xElement)
        {
            // TODO
            return null;
        }
    }
}
